<#ibiztemplate>
TARGET=PSDESERVICEAPI
</#ibiztemplate>
<#assign hasRS = true>
<#assign itemCodeName = item.getCodeName()>
<#assign itemSysApiCodeNameLC = item.getPSSysServiceAPI().getCodeName()?lower_case>
<#if item.isMajor()>
<#macro buildApi deapi rootPath levels>
<#if deapi.getPSDEServiceAPIMethods()??>
<#list deapi.getPSDEServiceAPIMethods() as apiMethod>
    <#assign deapiCodeName = deapi.getCodeName()>
    <#assign apide = deapi.getPSDataEntity()>
    <#assign apideCodeName = apide.getCodeName()>
    <#assign reqMtd = apiMethod.getRequestMethod()>
    <#if apiMethod.getActionType()=='DEACTION'>
        <#assign deaction = apiMethod.getPSDEAction()>
        <#assign deactionName = deaction.getName()>
        <#assign deactionCodeName = deaction.getCodeName()>
        <#assign apidePKCodeNameLC = apide.getKeyPSDEField().getCodeName()?lower_case>
	@ApiOperation(value = "${deaction.getLogicName()}", tags = {"${itemCodeName}" },  notes = "${deaction.getLogicName()}")
    @RequestMapping(method= RequestMethod.${reqMtd} , value="${rootPath}<#if (deactionName=='Create')><#else>/{${apidePKCodeNameLC}}</#if><#if (deactionName=='Get'||deactionName=='Create'||deactionName=='Update'||deactionName=='Remove')><#else>/${deactionCodeName?lower_case}</#if>")
	public <#if deactionName=='Remove'>boolean<#else>${deapiCodeName}DTO</#if> ${deactionCodeName?lower_case}${apideCodeName}(<#list levels as level>@PathVariable String ${level},</#list><#if deactionName=='Create'><#else>@PathVariable String ${apidePKCodeNameLC}</#if><#if deactionName='Get'||deactionName='Remove'><#else><#if deactionName!='Create'>,</#if>@RequestBody ${deapiCodeName}DTO dto</#if>) {
		<#comment>前期iid与id没做关联，暂时先自己service做操作</#comment>
		<#if deactionName=='Get'||deactionName=='Remove'>
		${deapiCodeName}DTO dto = new ${deapiCodeName}DTO();
		</#if>
		${deapiCodeName} po = dto.toPO();
		<#if deactionName!='Create'>
		po.set${apidePKCodeNameLC?cap_first}(${apidePKCodeNameLC});
		</#if>
		<#if deactionName=='Remove'>
		return ${deapiCodeName?lower_case}Service.${srfmethodname(deactionCodeName)}(po);
		<#else>
		${deapiCodeName?lower_case}Service.${srfmethodname(deactionCodeName)}(po);
		dto.fromPO(po);
		return dto;
		</#if>
	}

	<#elseif apiMethod.getActionType()=='FETCH'>
	    <#assign deds = apiMethod.getPSDEDataSet()>
	@ApiOperation(value = "获取${deds.getLogicName()}", tags = {"${itemCodeName}" } ,notes = "获取${deds.getLogicName()}")
    @RequestMapping(method= RequestMethod.${reqMtd} , value="${rootPath}/search<#if (deds.getName()=='DEFAULT')><#else>-${deds.getCodeName()?lower_case}</#if>")
	public List<${deapiCodeName}DTO> search${apideCodeName}<#if (deds.getName()=='DEFAULT')><#else>${deds.getCodeName()}</#if>(@PathVariable ${apideCodeName}SearchFilter searchFilter) {
	    ${deapiCodeName}DTO dto = new ${deapiCodeName}DTO();
	    return dto.fromPOPage(${deapiCodeName?lower_case}Service.search${deds.getCodeName()}(searchFilter));
	}
	</#if>
</#list>
</#if>
<#if deapi.getPSDEServiceAPIRSs()?? && hasRS>
<#list deapi.getPSDEServiceAPIRSs() as apider>
	<@buildApi deapi=apider.getMinorPSDEServiceAPI() rootPath= rootPath + '/{' + deapi.getPSDataEntity().getKeyPSDEField().getCodeName()?lower_case +'}/' + apider.getMinorPSDEServiceAPI().getCodeName()?lower_case levels= levels + [deapi.getPSDataEntity().getKeyPSDEField().getCodeName()?lower_case] />
</#list>
</#if>
</#macro>
package ${pub.getPKGCodeName()}.api.${itemSysApiCodeNameLC}.resource;

import java.util.List;

import ${pub.getPKGCodeName()}.${de.getPSSystemModule().getCodeName()?lower_case}.domain.${de.getCodeName()};
import ${pub.getPKGCodeName()}.${de.getPSSystemModule().getCodeName()?lower_case}.service.${de.getCodeName()}Service;
import ${pub.getPKGCodeName()}.${de.getPSSystemModule().getCodeName()?lower_case}.service.dto.${de.getCodeName()}SearchFilter;
<#if item.getPSDEServiceAPIRSs()?? && hasRS>
<#list item.getPSDEServiceAPIRSs() as apider>
<#assign deapide=apider.getMinorPSDEServiceAPI().getPSDataEntity()>
import ${pub.getPKGCodeName()}.${deapide.getPSSystemModule().getCodeName()?lower_case}.domain.${deapide.getCodeName()};
import ${pub.getPKGCodeName()}.${deapide.getPSSystemModule().getCodeName()?lower_case}.service.${deapide.getCodeName()}Service;
import ${pub.getPKGCodeName()}.${deapide.getPSSystemModule().getCodeName()?lower_case}.service.dto.${deapide.getCodeName()}SearchFilter;
</#list>
</#if>
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import ${pub.getPKGCodeName()}.api.${itemSysApiCodeNameLC}.dto.*;
import com.alibaba.fastjson.JSONObject;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;

<#if api.getAPIType() == "RESTFUL" >
@Api(tags = {"${itemCodeName}" })
@RestController
@RequestMapping("/rest/${itemSysApiCodeNameLC}/${item.getCodeName()?lower_case}")
</#if>
public class ${item.getCodeName()}Resource {

    @Autowired
    private ${de.codeName}Service ${de.codeName?lower_case}Service;

    <#if item.getPSDEServiceAPIRSs()?? && hasRS>
        <#list item.getPSDEServiceAPIRSs() as apider>
        <#assign deapide=apider.getMinorPSDEServiceAPI().getPSDataEntity()>
    @Autowired
    private ${deapide.codeName}Service ${deapide.codeName?lower_case}Service;

        </#list>
    </#if>
<#if api.getAPIType() == "RESTFUL" >
	<@buildApi deapi=item rootPath='' levels=[] />
</#if>
}
</#if>
